<?php

namespace RecruitCrm\LogicMelon\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAPIAdvertWithValues ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAPIAdvertWithValues
 * @subpackage Arrays
 */
class ArrayOfAPIAdvertWithValues extends AbstractStructArrayBase
{
    /**
     * The APIAdvertWithValues
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \RecruitCrm\LogicMelon\StructType\APIAdvertWithValues[]
     */
    public $APIAdvertWithValues;
    /**
     * Constructor method for ArrayOfAPIAdvertWithValues
     * @uses ArrayOfAPIAdvertWithValues::setAPIAdvertWithValues()
     * @param \RecruitCrm\LogicMelon\StructType\APIAdvertWithValues[] $aPIAdvertWithValues
     */
    public function __construct(array $aPIAdvertWithValues = array())
    {
        $this
            ->setAPIAdvertWithValues($aPIAdvertWithValues);
    }
    /**
     * Get APIAdvertWithValues value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \RecruitCrm\LogicMelon\StructType\APIAdvertWithValues[]|null
     */
    public function getAPIAdvertWithValues()
    {
        return isset($this->APIAdvertWithValues) ? $this->APIAdvertWithValues : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAPIAdvertWithValues method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAPIAdvertWithValues method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAPIAdvertWithValuesForArrayConstraintsFromSetAPIAdvertWithValues(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAPIAdvertWithValuesAPIAdvertWithValuesItem) {
            // validation for constraint: itemType
            if (!$arrayOfAPIAdvertWithValuesAPIAdvertWithValuesItem instanceof \RecruitCrm\LogicMelon\StructType\APIAdvertWithValues) {
                $invalidValues[] = is_object($arrayOfAPIAdvertWithValuesAPIAdvertWithValuesItem) ? get_class($arrayOfAPIAdvertWithValuesAPIAdvertWithValuesItem) : sprintf('%s(%s)', gettype($arrayOfAPIAdvertWithValuesAPIAdvertWithValuesItem), var_export($arrayOfAPIAdvertWithValuesAPIAdvertWithValuesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The APIAdvertWithValues property can only contain items of type \RecruitCrm\LogicMelon\StructType\APIAdvertWithValues, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set APIAdvertWithValues value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \RecruitCrm\LogicMelon\StructType\APIAdvertWithValues[] $aPIAdvertWithValues
     * @return \RecruitCrm\LogicMelon\ArrayType\ArrayOfAPIAdvertWithValues
     */
    public function setAPIAdvertWithValues(array $aPIAdvertWithValues = array())
    {
        // validation for constraint: array
        if ('' !== ($aPIAdvertWithValuesArrayErrorMessage = self::validateAPIAdvertWithValuesForArrayConstraintsFromSetAPIAdvertWithValues($aPIAdvertWithValues))) {
            throw new \InvalidArgumentException($aPIAdvertWithValuesArrayErrorMessage, __LINE__);
        }
        if (is_null($aPIAdvertWithValues) || (is_array($aPIAdvertWithValues) && empty($aPIAdvertWithValues))) {
            unset($this->APIAdvertWithValues);
        } else {
            $this->APIAdvertWithValues = $aPIAdvertWithValues;
        }
        return $this;
    }
    /**
     * Add item to APIAdvertWithValues value
     * @throws \InvalidArgumentException
     * @param \RecruitCrm\LogicMelon\StructType\APIAdvertWithValues $item
     * @return \RecruitCrm\LogicMelon\ArrayType\ArrayOfAPIAdvertWithValues
     */
    public function addToAPIAdvertWithValues(\RecruitCrm\LogicMelon\StructType\APIAdvertWithValues $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \RecruitCrm\LogicMelon\StructType\APIAdvertWithValues) {
            throw new \InvalidArgumentException(sprintf('The APIAdvertWithValues property can only contain items of type \RecruitCrm\LogicMelon\StructType\APIAdvertWithValues, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->APIAdvertWithValues[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \RecruitCrm\LogicMelon\StructType\APIAdvertWithValues|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \RecruitCrm\LogicMelon\StructType\APIAdvertWithValues|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \RecruitCrm\LogicMelon\StructType\APIAdvertWithValues|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \RecruitCrm\LogicMelon\StructType\APIAdvertWithValues|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \RecruitCrm\LogicMelon\StructType\APIAdvertWithValues|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string APIAdvertWithValues
     */
    public function getAttributeName()
    {
        return 'APIAdvertWithValues';
    }
}
